sed -i -e "s_^\\($1\\s.*A\\s.*\\s\\)\\([0-9]\\+\\.\\)\\+[0-9]\\+_\\1$3_g" "$2"
}
-function getSerialFromZonefile # <zonefile>
-{
- awk '/; serial/{print$1}' "$1"
-}
-
-function setSerialInZonefile # <zonefile> <serial>
-{
- sed -i -e "s_^\\(.*\\s\\)[0-9]\+\\(\\s\\+; serial.*\\)_\\1$2\\2_g" "$1"
-}
function run()
{
fi
if ! [ "${oldip}" = "${newip}" ]; then
- serial=`getSerialFromZonefile "${zonefile}"`
- serial=$(( $serial + 1))
- echo " Update IP address. New serial ${serial}."
+ echo " Update IP address. Increment serial."
setAddrInZonefile "${host}" "${zonefile}" "${newip}"
- setSerialInZonefile "${zonefile}" "${serial}"
+ nsd-incrserial "${zonefile}"
+
/etc/nsd3/signzone.sh sthu.org
nsdc rebuild && nsdc reload && nsdc notify
fi
--- /dev/null
+#!/bin/sh
+
+# Copyright (c) 2013 Stefan Huber <shuber@sthu.org>
+#
+# Permission is hereby granted, free of charge, to any person
+# obtaining a copy of this software and associated documentation
+# files (the "Software"), to deal in the Software without
+# restriction, including without limitation the rights to use,
+# copy, modify, merge, publish, distribute, sublicense, and/or sell
+# copies of the Software, and to permit persons to whom the
+# Software is furnished to do so, subject to the following
+# conditions:
+#
+# The above copyright notice and this permission notice shall be
+# included in all copies or substantial portions of the Software.
+#
+# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
+# OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
+# HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
+# WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+# OTHER DEALINGS IN THE SOFTWARE.
+
+set -e
+
+PROGNAME=$(basename $0)
+
+usage() {
+ cat <<EOF
+Increments serial in zonefile by one.
+
+Usage: $PROGNAME zonefile [OPTIONS]
+
+Options:
+ -h, --help Print this text.
+EOF
+}
+
+TEMP=`getopt -o "h" --long "help" -n "$PROGNAME" -- "$@"`
+eval set - "$TEMP"
+
+while true; do
+ case "$1" in
+ -h | --help )
+ usage
+ exit $STATE_OK ;;
+ -- )
+ shift
+ break ;;
+ * )
+ break ;;
+ esac
+done
+
+if [ "$#" = "0" ]; then
+ echo "Not enough arguments."
+ usage
+ exit 1
+fi
+
+zonefile=$1
+if ! [ -r "${zonefile}" ]; then
+ echo "Zone file does not exist: '${zonefile}'"
+ exit 2
+fi
+
+getSerialFromZonefile() # <zonefile>
+{
+ awk '/; serial/{print$1}' "$1"
+}
+
+setSerialInZonefile() # <zonefile> <serial>
+{
+ sed -i -e "s_^\\(.*\\s\\)[0-9]\+\\(\\s\\+; serial.*\\)_\\1$2\\2_g" "$1"
+}
+
+
+serial=`getSerialFromZonefile "${zonefile}"`
+serial=$(( $serial + 1))
+
+if [ -z "$serial" ]; then
+ echo "Internal error, serial is empty."
+ exit 1
+fi
+
+setSerialInZonefile "${zonefile}" "${serial}"
+